<script>
import { getToken } from "@/utils/auth";
import { IMPORTTEMPLATE } from "@/api/business/purchase/contract";
export default {
  name: "ImportDialog",
  data() {
    return {
      visible: false,
      upload: {
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {
          Authorization: "Bearer " + getToken(),
        },
        // 上传的地址
        url: "/drp-file/document-center/fastdfs/upload",
      },
    };
  },
  computed: {},
  watch: {},
  methods: {
    //
    open(prop) {
      this.visible = true;
    },
    //
    hide() {
      this.visible = false;
    },
    //
    async importTemplate() {
      try {
        const { msg, code } = await IMPORTTEMPLATE();
        if (code === 200) {
          this.download(msg, {});
        } else {
          this.$notify.warning({ title: msg });
        }
      } catch (err) {
        // catch
      } finally {
        // finally
      }
    },
    // 文件上传中处理
    progress(event, file, fileList) {
      console.log(event, file, fileList);
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    success(response, file, fileList) {
      const { message: msg } = response;
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(msg, "导入结果", {
        dangerouslyUseHTMLString: true,
      });
      this.getList();
    },
    //
    confirm() {
      this.$refs.upload.submit();
    },
  },
  created() {},
  mounted() {},
  destroyed() {},
};
</script>
<template>
  <el-dialog title="导入" width="fit-content" :visible.sync="visible">
    <el-upload
      ref="upload"
      :limit="1"
      accept=".xlsx, .xls"
      :headers="upload.headers"
      :action="upload.url + '?updateSupport=' + upload.updateSupport"
      :disabled="upload.isUploading"
      :on-progress="progress"
      :on-success="success"
      :auto-upload="false"
      drag
    >
      <i class="el-icon-upload"></i>
      <div class="el-upload__text">
        将文件拖到此处，或
        <em>点击上传</em>
      </div>
      <div
        class="el-upload__tip"
        slot="tip"
        style="display: flex; align-items: center"
      >
        <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
        <el-link
          type="info"
          style="font-size: 12px; margin-left: 10px"
          @click="importTemplate"
        >
          下载模板
        </el-link>
      </div>
      <div class="el-upload__tip" style="color: red" slot="tip">
        提示：仅允许导入“xls”或“xlsx”格式文件！
      </div>
    </el-upload>
    <div slot="footer" class="dialog-footer">
      <el-button type="primary" @click="confirm">确 定</el-button>
      <el-button @click="hide">取 消</el-button>
    </div>
  </el-dialog>
</template>
